#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# IMPORTS
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

from src.local.typing import *;

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# EXPORTS
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

__all__ = [
    'Stack',
];

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# CLASS Stack
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

class Stack:
    '''
    A data structure for stacks
    '''
    values: list[Any];

    def __init__(self):
        self.values = [];
        return;

    def __len__(self):
        '''
        @returns
        number of elements in stack
        '''
        return len(self.values);

    def __contains__(self, value: Any) -> bool:
        return value in self.values;

    def push(self, value: Any):
        '''
        add element to stack
        '''
        self.values.append(value);

    def pop(self) -> Any:
        '''
        @returns
        top element from stack and removes it
        '''
        value = self.top();
        self.values = self.values[:-1];
        return value;

    def top(self) -> Any:
        '''
        @returns
        top element from stack without removal
        '''
        if len(self.values) == 0:
            raise Exception('Stack is empty!');
        return self.values[-1];
